# Licensed under the MIT license
# http://opensource.org/licenses/mit-license.php or see LICENSE file.
# Copyright 2007-2008 Brisa Team <brisa-develop@garage.maemo.org>

import logging
from logging import getLogger, debug, info, warning, error
from brisa import config
import traceback
import os

log_dict = {'CRITICAL': logging.CRITICAL, 'ERROR': logging.ERROR,
            'WARNING': logging.WARNING, 'DEBUG': logging.DEBUG,
            'NOTSET': logging.NOTSET, 'INFO': logging.INFO}


def show_exception(message, e, haltSignal=None):
    print message
    print ("%s%s%s%s") % ("Exception type / message: ", str(type(e)), " / ",
                          e.message)
    traceback.print_exc()
    if isinstance(haltSignal, int):
        print ("%s%s%s") % ("System will be halted with signal ",
                            str(haltSignal), " due to exception.")
        os._exit(haltSignal)


def set_level(level, filename):
    log_level = log_dict.get(level)

    if not log_level:
        log_level = log_dict.get('NOTSET')

    logging.filename = filename

    if filename == 'stdout':
        filename = None
    else:
        filename = os.path.join(config.brisa_home, "brisa.log")
        logging.filename = filename

    logging.basicConfig(level=log_level, filename=filename)


output = 'stdout'
if config.contains(section='logging', parameter='output'):
    output = config.get_parameter(section='logging', parameter='output')

level = ''
if config.contains(section='logging', parameter='level'):
    level = config.get_parameter(section='logging', parameter='level')

set_level(level, output)
filename = logging.filename
logging.show_exception = show_exception
