# Licensed under the MIT license
# http://opensource.org/licenses/mit-license.php or see LICENSE file.
# Copyright 2007-2008 Brisa Team <brisa-develop@garage.maemo.org>

import os
from brisa import config

"""
 Resolve database connection.
 Parameters:
    database_uri: the database uri to be resolved
    database_name: if database_path doesn't exists, it resolve the database
                   connection to brisa_home/[database_name]
    protocol: protocol to be used to connect to the database
 Returns: the database resolved path
"""


def resolve_database(database_uri, database_name, protocol="sqlite"):
    if ':' in database_uri:
        db_filesystem_path = database_uri.split(':')[1]
    else:
        db_filesystem_path = database_uri
    if not os.path.exists(db_filesystem_path):
        database_uri = os.path.join(config.brisa_home, database_name)
        database_uri = "%s:%s" % (protocol, database_uri)
    return db_filesystem_path
