# Licensed under the MIT license
# http://opensource.org/licenses/mit-license.php or see LICENSE file.
# Copyright 2007-2008 Brisa Team <brisa-develop@garage.maemo.org>

from threading import Thread, Timer
from time import sleep, time

from brisa import log
from brisa.main import sleep

class LoopingCall(Thread):

    def __init__(self, f, *a, **kw):
        Thread.__init__(self)
        self.function = f
        self.a = a
        self.kw = kw
        self.interval = 0
        self.running = False

    def start(self, interval, now=True):
        self.interval = interval

        assert interval != 0, ('(warning) starting LoopingCall with \
                                interval %f' % self.interval)

        if now:
            Thread.start(self)
        else:
            Timer(interval, Thread.start, self)

    def run(self):
        log.debug("LoopingCall started, interval %f" % self.interval)
        self.running = True

        while self.running:
            #log.debug("LoopingCall action performed %f" % self.interval)
            self.function(*self.a, **self.kw)
            sleep(self.interval)

    def stop(self):
        self.running = False
